misc/config_tools/config_app/views.py
# Copyright (C) 2019 Intel Corporation.
# SPDX-License-Identifier: BSD-3-Clause

"""View pages for config app.

"""

import os, copy
from datetime import datetime
from shutil import copyfile

# flask: Copyright 2010 Pallets
# SPDX-License-Identifier: BSD-3-Clause
# Refer to https://github.com/pallets/flask/blob/master/LICENSE.rst for the permission notice.
from flask import request, render_template, Blueprint, redirect, url_for, current_app

# werkzeug: Copyright 2007 Pallets
# SPDX-License-Identifier: BSD-3-Clause
# Refer to https://github.com/pallets/werkzeug/blob/master/LICENSE.rst for the permission notice.
from werkzeug.utils import secure_filename

from controller import *
from scenario_config.scenario_cfg_gen import get_scenario_item_values
from scenario_config.scenario_cfg_gen import validate_scenario_setting
from launch_config.launch_cfg_gen import get_launch_item_values
from launch_config.launch_cfg_gen import validate_launch_setting
from library.common import MAX_VM_NUM


CONFIG_APP = Blueprint('CONFIG_APP', __name__, template_folder='templates')


@CONFIG_APP.route('/')
def index():
    """
    render the index page
    :return: the render template of index page
    """
    return redirect(url_for('CONFIG_APP.scenarios'))


@CONFIG_APP.route('/scenario', methods=['GET'])
def scenarios():
    """
    render the scenario parent setting page
    :return: the render template of scenario setting parent page
    """
    board_info, board_type, scenario_config, launch_config = get_xml_configs()
    (bios_info, base_board_info) = get_board_info(board_info)

    return render_template('scenario.html', board_info_list=get_board_list(),
                           board_info=board_info, board_type=board_type,
                           bios_info=bios_info, base_board_info=base_board_info,
                           scenarios=scenario_config.list_all(xml_type='scenario'),
                           launches=launch_config.list_all(xml_type='uos_launcher'),
                           scenario='', root=None)


@CONFIG_APP.route('/scenario/<scenario_name>', methods=['GET'])
def scenario(scenario_name):
    """
    render the specified scenario setting page
    :param scenario_name: the scenario type
    :return: the render template of the specified scenario setting page
    """

    board_info, board_type, scenario_config, launch_config = get_xml_configs()
    (bios_info, base_board_info) = get_board_info(board_info)
    xpath_dict = get_xpath_dict_of_xsd()

    current_app.config.update(SCENARIO=scenario_name)

    scenario_config.set_curr(scenario_name)

    scenario_item_values = {}
    if board_info is not None and board_type is not None:
        scenario_file_path = os.path.join(current_app.config.get('CONFIG_PATH'), board_type,
                                          'user_defined', scenario_name + '.xml')
        if os.path.isfile(scenario_file_path):
            scenario_item_values = get_scenario_item_values(
                os.path.join(os.path.dirname(os.path.abspath(__file__)), 'res', board_info+'.xml'),
                scenario_file_path)
    for xpath in xpath_dict:
        if xpath_dict[xpath]['enumeration'] and len(xpath.split('/')) > 2:
            scenario_item_values[','.join(xpath.split('/')[2:])] = xpath_dict[xpath]['enumeration']

    return render_template('scenario.html', board_info_list=get_board_list(),
                           board_info=board_info, board_type=board_type,
                           bios_info=bios_info, base_board_info=base_board_info,
                           scenarios=scenario_config.list_all(xml_type='scenario'),
                           launches=launch_config.list_all(xml_type='uos_launcher'),
                           scenario=scenario_name, root=scenario_config.get_curr_root(),
                           scenario_item_values=scenario_item_values,
                           xpath_dict=xpath_dict)


@CONFIG_APP.route('/launch', methods=['GET'])
def launches():
    """
    render the parent launch setting page
    :return: the render template of launch setting page
    """
    board_info, board_type, scenario_config, launch_config = get_xml_configs()
    (bios_info, base_board_info) = get_board_info(board_info)

    return render_template('launch.html', board_info_list=get_board_list(),
                           board_info=board_info, board_type=board_type,
                           bios_info=bios_info, base_board_info=base_board_info,
                           scenarios=scenario_config.list_all(xml_type='scenario'),
                           launches=launch_config.list_all(xml_type='uos_launcher'),
                           launch='', root=None)


@CONFIG_APP.route('/launch/<launch_name>', methods=['GET'])
def launch(launch_name):
    """
    render the specified launch setting page
    :param launch_name: the launch type
    :return: the render template of specified launch setting page
    """
    board_info, board_type, scenario_config, launch_config = get_xml_configs()
    (bios_info, base_board_info) = get_board_info(board_info)

    launch_config.set_curr(launch_name)

    launch_item_values = {}
    scenario_name = launch_config.get_curr_root().attrib['scenario']
    current_app.config.update(SCENARIO=scenario_name)
    scenario_name = current_app.config.get('SCENARIO')
    scenario_file = None
    if board_info is not None and scenario_name is not None:
        scenario_file = os.path.join(current_app.config.get('CONFIG_PATH'), board_type, 'user_defined',
                                     scenario_name+'.xml')
        if not os.path.isfile(scenario_file):
            scenario_file = os.path.join(current_app.config.get('CONFIG_PATH'), board_type,
                                         scenario_name + '.xml')
            if not os.path.isfile(scenario_file):
                scenario_file = None
        launch_item_values = get_launch_item_values(
            os.path.join(os.path.dirname(os.path.abspath(__file__)), 'res', board_info + '.xml'), scenario_file)

    scenario_name = None
    launch_config_root = launch_config.get_curr_root()
    if launch_config_root is not None and 'scenario' in launch_config_root.attrib:
        scenario_name = launch_config_root.attrib['scenario']
    post_launch_vm_list = get_post_launch_vm_list(scenario_name)

    return render_template('launch.html', board_info_list=get_board_list(),
                           board_info=board_info, board_type=board_type,
                           bios_info=bios_info, base_board_info=base_board_info,
                           scenarios=scenario_config.list_all(xml_type='scenario'),
                           launches=launch_config.list_all(xml_type='uos_launcher'),
                           launch=launch_name, root=launch_config.get_curr_root(),
                           scenario=current_app.config.get('SCENARIO'),
                           post_launch_vm_list=post_launch_vm_list,
                           launch_item_values=launch_item_values)


@CONFIG_APP.route('/save_scenario', methods=['POST'])
def save_scenario():
    """
    save scenario setting.
    :return: the error list for the edited scenario setting.
    """
    scenario_config_data = request.json if request.method == "POST" else request.args
    xml_configs = get_xml_configs()
    board_type = xml_configs[1]
    scenario_config = xml_configs[3]

    if board_type is None or xml_configs[0] is None:
        return {'status': 'fail',
                'error_list': {'error': 'Please select the board info before this operation.'}}

    scenario_path = os.path.join(current_app.config.get('CONFIG_PATH'), board_type)
    old_scenario_name = scenario_config_data['old_scenario_name']
    scenario_config.set_curr(old_scenario_name)

    for vm in list(scenario_config.get_curr_root()):
        if vm.tag == 'vm':
            for elem in list(vm):
                if elem.tag in ['communication_vuart', 'console_vuart']:
                    vuart_key = vm.tag+':id='+vm.attrib['id']+','+elem.tag + ':id='+elem.attrib['id']
                    delete_flag = True
                    for key in scenario_config_data:
                        if key.find(vuart_key) >= 0:
                            delete_flag = False
                            break
                    if delete_flag:
                        scenario_config.delete_curr_elem(*tuple(vuart_key.split(',')))

    for key in scenario_config_data:
        if scenario_config_data[key] in [None, 'None']:
            scenario_config_data[key] = ''

        if key not in ['old_scenario_name', 'new_scenario_name', 'generator', 'add_vm_type']:
            if isinstance(scenario_config_data[key], list):
                scenario_config.set_curr_list(scenario_config_data[key], *tuple(key.split(',')))
            elif key.find('communication_vuart') >= 0:
                try:
                    scenario_config.get_curr_elem(*tuple(key.split(',')))
                except:
                    communication_vuart_id = key.split(',')[1].split('=')[1].strip()
                    communication_vuart_1_item = scenario_config.get_curr_elem(
                        *tuple([key.split(',')[0], 'communication_vuart:id=1']))
                    communication_vuart_i_item = copy.deepcopy(communication_vuart_1_item)
                    communication_vuart_i_item.attrib['id'] = communication_vuart_id
                    curr_index = 0
                    elem_list = list(scenario_config.get_curr_elem(key.split(',')[0]))
                    for elem in reversed(elem_list):
                        curr_index += 1
                        if elem.tag in ['communication_vuart', 'console_vuart']:
                            break
                    scenario_config.insert_curr_elem(len(elem_list)-curr_index+1, communication_vuart_i_item, key.split(',')[0])
                finally:
                    scenario_config.set_curr_value(scenario_config_data[key], *tuple(key.split(',')))
            else:

misc/config_tools/config_app/templates/base.html
<!DOCTYPE html>
<html lang="en">

<head>
    <meta charset="UTF-8">
    <title>{% block title %}{% endblock %}</title>
    <link href="https://cdn.staticfile.org/twitter-bootstrap/3.0.3/css/bootstrap.min.css" rel="stylesheet">
    <script src="https://cdn.staticfile.org/jquery/2.1.1/jquery.min.js"></script>
    <script src="https://cdn.staticfile.org/twitter-bootstrap/3.0.3/js/bootstrap.min.js"></script>
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.10.0/css/bootstrap-select.min.css">
    <script src="https://cdnjs.cloudflare.com/ajax/libs/bootstrap-select/1.10.0/js/bootstrap-select.min.js"></script>
    <link href="../static/styles.css" rel="stylesheet" type="text/css">
    <script src="../static/main.js" type="text/javascript"></script>
</head>

<body>

<div class="modal fade" id="create_modal" tabindex="-1" role="dialog" aria-labelledby="createModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <button type="button" class="close" data-dismiss="modal" aria-hidden="true">&times;</button>
                <h4 class="modal-title" id="createModalLabel"></h4>
            </div>
            <div class="modal-body">
                <div class="form-group row">
                    <label for="create_name" class="col-sm-3 control-label">Name: </label>
                    <div class="col-sm-6">
                        <input type="text" class="form-control" id="create_name"
                               value="">
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
                <button type="button" id="create_btn" data-id="" class="btn btn-primary">OK
                </button>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="load_scenario_modal" tabindex="-1" role="dialog" aria-labelledby="loadScenarioModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title" id="loadScenarioModalLabel">Load Scenario Setting</h4>
            </div>
            <div class="modal-body">
                <div class="form-group row">
                    <label for="load_scenario_name" class="col-sm-3 control-label">Default Scenario Setting: </label>
                    <div class="dropdown col-sm-6">
                        <select class="selectpicker" data-width="auto" id="load_scenario_name">
                            {% if scenarios[0] %}
                                {% for sc in scenarios[0] %}
                                <option value="{{sc}}">{{sc}}</option>
                                {% endfor %}
                            {% endif %}
                        </select>
                    </div>
                </div>
                <div class="form-group row">
                    <label for="load_scenario_name2" class="col-sm-3 control-label">Scenario Setting Name: </label>
                    <div class="col-sm-6">
                        <input type="text" class="form-control" id="load_scenario_name2"
                               value="{{scenarios[0][0] if scenarios[0] else ''}}">
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
                <button type="button" id="load_scenario_btn" data-id="scenario" class="btn btn-primary">OK
                </button>
            </div>
        </div>
    </div>
</div>

<div class="modal fade" id="load_launch_modal" tabindex="-1" role="dialog" aria-labelledby="loadLaunchModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <div class="modal-header">
                <h4 class="modal-title" id="loadLaunchModalLabel">Load Launch setting</h4>
            </div>
            <div class="modal-body">
                <div class="form-group row">
                    <label for="load_launch_name" class="col-sm-3 control-label">Default Launch Setting: </label>
                    <div class="dropdown col-sm-6">
                        <select class="selectpicker" data-width="auto" id="load_launch_name">
                            {% if launches[0] %}
                                {% for lc in launches[0] %}
                                <option value="{{lc}}">{{lc}}</option>
                                {% endfor %}
                            {% endif %}
                        </select>
                    </div>
                </div>
                <div class="form-group row">
                    <label for="load_launch_name2" class="col-sm-3 control-label">Launch Setting Name: </label>
                    <div class="col-sm-6">
                        <input type="text" class="form-control" id="load_launch_name2"
                               value="{{launches[0][0] if launches[0] else ''}}">
                    </div>
                </div>
            </div>
            <div class="modal-footer">
                <button type="button" class="btn btn-default" data-dismiss="modal">Cancel</button>
                <button type="button" id="load_launch_btn" data-id="launch" class="btn btn-primary">OK
                </button>
            </div>
        </div>
    </div>
</div>

<nav class="navbar navbar-inverse">
    <div class="container-fluid">
        <div class="navbar-header">
            <a class="navbar-brand" href="{{ url_for('CONFIG_APP.scenarios') }}">ACRN Config</a>
        </div>
        <ul class="nav navbar-nav">
            <li class="dropdown">
                <a href="{{ url_for('CONFIG_APP.scenarios') }}">
                    Scenario Setting <span class="caret"></span></a>
                <ul class="dropdown-menu">
                    {% if scenarios[0] %}
                        <li><a href="" data-toggle="modal" data-target="#create_modal"  class="create_menu"
                               data-id="scenario">Create a new scenario</a></li>
                        <li><a href="" data-toggle="modal" data-target="#load_scenario_modal"  class="load_menu"
                               data-id="scenario">Load a default scenario</a></li>
                        <small class="text-muted">scenario setting list</small>
                        {% for sc in scenarios[1] %}
                        <li><a href="{{ url_for('CONFIG_APP.scenario', scenario_name=sc) }}">{{sc}}</a></li>
                        {% endfor %}
                    {% else %}
                        <text class="form-control" id="err_msg" data-toggle="tooltip"
                              title="No board selected or not supported board">No Setting
                        </text>
                    {% endif %}
                </ul>
            </li>
            <li class="dropdown">
                <a href="{{ url_for('CONFIG_APP.launches') }}">Launch Setting <span
                        class="caret"></span></a>
                <ul class="dropdown-menu">
                    {% if launches[0] %}
                        <li><a href="" data-toggle="modal" data-target="#create_modal" class="create_menu"
                               data-id="launch">Create a new Launch script</a></li>
                        <li><a href="" data-toggle="modal" data-target="#load_launch_modal"  class="load_menu"
                               data-id="launch">Load a default launch script</a></li>
                        <small class="text-muted">launch setting list</small>
                        {% for lc in launches[1] %}
                        <li><a href="{{ url_for('CONFIG_APP.launch', launch_name=lc) }}">{{lc}}</a></li>
                        {% endfor %}
                    {% else %}
                        <text class="form-control" id="err_msg" data-toggle="tooltip"
                              title="No board selected or not supported board">No Setting
                        </text>
                    {% endif %}
                </ul>
            </li>
        </ul>
    </div>
</nav>
<form class="form-horizontal" action="" enctype="multipart/form-data" method='POST'>
    <div class="form-group">
        <label class="col-sm-1 control-label" style="text-align: left;">&nbsp;&nbsp;Board info:</label>
        <div class="col-sm-2">
            <div class="dropdown">
                <select class="selectpicker" id="board_info">
                    <option disabled selected value> -- Select an option -- </option>
                    {% for bi in board_info_list %}
                        {% if bi==board_info %}
                        <option value="{{bi}}" selected="selected">{{bi}}</option>
                        {% else %}
                        <option value="{{bi}}">{{bi}}</option>
                        {% endif%}
                    {% endfor %}
                </select>
            </div>
        </div>
        <label class="col-sm-1 control-label">&nbsp;&nbsp;Board name:</label>
        <text class="col-sm-2 control-label" id="board_type" style="text-align: left;">{{board_type if board_type != None else ''}}</text>
        <div class="col-sm-6">
            <form action="" enctype="multipart/form-data" method='POST'>
                <label for="board_info_file" class="custom-file-upload btn btn-primary" id="board_info_file2"
                       style="border: 1px solid #ccc; display: inline-block; padding: 6px 12px;
                           cursor: pointer; border-radius:5px; ">
                    Import Board info</label>
                <input type="file" name="file" id="board_info_file" class="col-sm-6 btn btn-primary"
                       style="display: none;">
            </form>
        </div>
    </div>
    <div class="form-group">
        <label class="col-sm-1"></label>
        <text class="col-sm-2 control-label" id="bios_info" style="white-space: pre-line">{{bios_info if bios_info != None else ''}}</text>
        <label class="col-sm-1"></label>
        <text class="col-sm-2" id="base_board_info" style="white-space: pre-line">{{base_board_info if base_board_info != None else ''}}</text>
    </div>
</form>
<hr class="col-sm-12">

{% block body_content %}

{% endblock %}

</body>

</html>